#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <shop>

#define PLUGIN_VERSION	"2.1.0"

#define CATEGORY	"ability"
#define ITEM		"speed"

new Handle:g_hSpeed, Float:g_fSpeed,
	Handle:g_hPrice, g_iPrice;

new bool:HasSpeed[MAXPLAYERS+1];

new ItemId:id;

public Plugin:myinfo =
{
	name = "[Shop] Speed",
	author = "FrozDark (HLModders LLC)",
	description = "Speed ability",
	version = PLUGIN_VERSION,
	url = "http://www.hlmod.ru/"
};

public OnPluginStart()
{
	g_hSpeed = CreateConVar("sm_shop_speed_amount", "1.2", "Speed amount. 1.0 - normal.", 0, true, 0.1);
	g_fSpeed = GetConVarFloat(g_hSpeed);
	HookConVarChange(g_hSpeed, OnConVarChange);
	
	g_hPrice = CreateConVar("sm_shop_speed_price", "10000", "Price for the speed ability.");
	g_iPrice = GetConVarInt(g_hPrice);
	HookConVarChange(g_hPrice, OnConVarChange);
	
	AutoExecConfig(true, "shop_speed", "shop");
	
	HookEvent("player_spawn", PlayerSpawn);
	HookEvent("round_end", RoundEnd);
	
	if (Shop_IsStarted()) Shop_Started();
}

public OnPluginEnd()
{
	Shop_UnregisterMe();
}

public OnClientDisconnect_Post(client)
{
	HasSpeed[client] = false;
}

public Shop_Started()
{
	new CategoryId:category_id = Shop_RegisterCategory(CATEGORY, "Способности", "");
	
	if (Shop_StartItem(category_id, ITEM))
	{
		Shop_SetInfo("Скорость", "", g_iPrice, -1, Item_BuyOnly);
		Shop_SetCallbacks(OnItemRegistered, _, _, OnDisplay, _, _, OnBuy);
		Shop_EndItem();
	}
}

public OnItemRegistered(CategoryId:category_id, const String:category[], const String:item[], ItemId:item_id)
{
	id = item_id;
}

public bool:OnDisplay(client, CategoryId:category_id, const String:category[], ItemId:item_id, const String:item[], ShopMenu:menu, &bool:disabled, const String:name[], String:buffer[], maxlen)
{
	FormatEx(buffer, maxlen, "Скорость: %.1fx", g_fSpeed);
	if (HasSpeed[client])
	{
		disabled = true;
		return true;
	}
	return true;
}

public bool:OnBuy(client, CategoryId:category_id, const String:category[], ItemId:item_id, const String:item[], ItemType:type, price, sell_price, value)
{
	if (HasSpeed[client])
	{
		PrintToChat(client, "\x04[Shop] \x01У вас уже есть скорость!");
		return false;
	}
	HasSpeed[client] = true;
	SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", g_fSpeed);
	
	PrintToChat(client, "\x04[Shop] \x01Вы успешно купили скорость!");
	
	return true;
}

public OnConVarChange(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if (convar == g_hSpeed)
	{
		g_fSpeed = StringToFloat(newValue);
	}
	else if (convar == g_hPrice)
	{
		g_iPrice = StringToInt(newValue);
		Shop_SetItemPrice(id, g_iPrice);
	}
}

public RoundEnd(Handle:event,const String:name[],bool:dontBroadcast)
{
	for (new i = 1; i <= MaxClients; i++)
	{
		HasSpeed[i] = false;
	}
}

public PlayerSpawn(Handle:event,const String:name[],bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if (!client) return;
	
	CreateTimer(0.0, SetSpeed, client);
}

public Action:SetSpeed(Handle:timer, any:client)
{
	if (HasSpeed[client])
	{
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", g_fSpeed);
	}
	else
	{
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.0);
	}
}